IMPLEMENTATION MODULE DynStr;

  FROM Storage IMPORT ALLOCATE, DEALLOCATE;
  FROM InOut IMPORT Read, Write, EOL;
  FROM SYSTEM IMPORT TSIZE;

  TYPE TestString = ARRAY[0..15] OF CHAR;
  VAR Packung : CARDINAL;

  PROCEDURE length(VAR S : ARRAY OF CHAR) : CARDINAL;
    VAR i : CARDINAL;
    BEGIN
      i:=0;
      WHILE (i<=HIGH(S)) AND (S[i]>0C) DO INC(i) END;
      RETURN i
    END length;

  PROCEDURE MakeDynString(StatString : ARRAY OF CHAR; VAR S : DynString);
    VAR BenoetigteWorte, AnzahlBytes, i : CARDINAL;
    BEGIN
      AnzahlBytes:=length(StatString)+1;
      BenoetigteWorte:=(AnzahlBytes+Packung-1) DIV Packung;
      ALLOCATE(S,BenoetigteWorte);
      FOR i:=0 TO AnzahlBytes-1 DO S^[i]:=StatString[i] END;
      S^[AnzahlBytes]:=0C
    END MakeDynString;

  PROCEDURE MakeStatString(VAR StatString : ARRAY OF CHAR; S : DynString);
    VAR i : CARDINAL;
    BEGIN
      FOR i:=0 TO length(S^) DO
        IF i>HIGH(StatString)
        THEN RETURN
        ELSE StatString[i]:=S^[i]
        END (* IF *)
      END (* FOR *)
    END MakeStatString;

  PROCEDURE ReadDynString(VAR S : DynString);
    CONST MaxStringLaenge = 255;
    VAR Puffer : ARRAY[0..MaxStringLaenge] OF CHAR;
        i : CARDINAL;
        Zeichen : CHAR;
    BEGIN
      i:=0;
      REPEAT
        Read(Zeichen); Puffer[i]:=Zeichen; INC(i)
      UNTIL (i>MaxStringLaenge) OR (Zeichen=EOL);
      IF Zeichen=EOL THEN Puffer[i-1]:=0C END;
      MakeDynString(Puffer,S)
    END ReadDynString;

  PROCEDURE WriteDynString(S : DynString);
    VAR i : CARDINAL;
    BEGIN
      i:=0; WHILE S^[i]<>0C DO Write(S^[i]); INC(i) END
    END WriteDynString;

  PROCEDURE ForgetDynString(VAR S : DynString);
    VAR BenoetigteWorte, AnzahlBytes, i : CARDINAL;
    BEGIN
      AnzahlBytes:=length(S^)+1;
      BenoetigteWorte:=(AnzahlBytes+Packung-1) DIV Packung;
      DEALLOCATE(S,BenoetigteWorte)
    END ForgetDynString;

  PROCEDURE DynStringLength(S : DynString):CARDINAL;
    BEGIN
      RETURN length(S^)
    END DynStringLength;

  PROCEDURE CompareDynString(S1, S2 : DynString):INTEGER;
    VAR i : CARDINAL;
    BEGIN
      i:=0;
      LOOP
        IF S1^[i]<S2^[i] THEN RETURN -1
        ELSIF S1^[i]>S2^[i] THEN RETURN 1
        ELSIF S1^[i]=0C THEN RETURN 0
        ELSE INC(i)
        END
      END (* LOOP *)
    END CompareDynString;

  BEGIN
    Packung:=16 DIV TSIZE(TestString)
  END DynStr.