MODULE FileTest;

FROM LOWFILES IMPORT LowFile, ResetLowFile, CloseLowFile, ReadNBytes,
                     LowFileSize, FilePos;
FROM ChipIO IMPORT Write, WriteString, WriteCard, ReadString,
                   WriteLn, ReadKey, ClrScr;

VAR FileName : ARRAY[0..40] OF CHAR;
    f : LowFile;
    Buffer : ARRAY[0..15],[0..15] OF CHAR;
    FilePosition : FilePos;
    okay : INTEGER;

PROCEDURE WriteHex(C : CHAR);
  VAR HI, LO : CARDINAL;
  BEGIN
    HI:=ORD(C) DIV 16; LO:=ORD(C) MOD 16;
    IF HI<10 THEN INC(HI,48) ELSE INC(HI,55) END;
    IF LO<10 THEN INC(LO,48) ELSE INC(LO,55) END;
    Write(CHR(HI)); Write(CHR(LO))
  END WriteHex;

PROCEDURE WriteChar(C : CHAR);
  BEGIN
    IF C>=" " THEN Write(C) ELSE Write(".") END
  END WriteChar;

PROCEDURE ShowPage;
  VAR i,j : CARDINAL;
  BEGIN
    ClrScr; WriteString("Datei: "); WriteString(FileName);
    WriteString(", Seite ");
    WriteCard(1+VAL(CARDINAL,FilePosition) DIV 256,1);
    WriteLn; WriteLn;
    FOR i:=0 TO 15 DO
      FOR j:=0 TO 15 DO WriteHex(Buffer[i,j]); WriteString(" ") END;
      WriteString("   ");
      FOR j:=0 TO 15 DO WriteChar(Buffer[i,j]) END;
      WriteLn
    END (* FOR *)
  END ShowPage;

BEGIN
  WriteString("Datei: "); ReadString(FileName); WriteLn;
  ResetLowFile(f,FileName,okay);
  IF okay<>0 THEN WriteString("Datei existiert nicht!"); WriteLn; HALT END;
  FilePosition:=0;
  LOOP
    ReadNBytes(f,FilePosition,256,Buffer,okay);
    IF okay<>0 THEN WriteString("Lesefehler!"); HALT END;
    ShowPage; WriteLn;
    WriteString("V)or R)ck E)nde ");
    CASE CAP(ReadKey()) OF
      "V" : IF FilePosition<LowFileSize(f,okay)
            THEN FilePosition:=FilePosition+VAL(FilePos,256)
            END;
    | "R" : IF FilePosition>255
            THEN FilePosition:=FilePosition-VAL(FilePos,256)
            END;
    | "E" : EXIT
    ELSE (* ignorieren *)
    END
  END; (* LOOP *)
  CloseLowFile(f,okay)
END FileTest.