MODULE FRAKTALE;

  FROM ChipIO IMPORT
    GotoXY, ClrScr, ReadKey, Write,
    WriteString, WriteReal, WriteLn,
    ReadReal, ReadLn, KeyPressed, Done;

  FROM COMPLEX IMPORT
    Complex, CABS, CADD, CSUB, CMUL;

  FROM Graph IMPORT   (* Bei TopSpeed *)
    InitHerc, InitEGA, InitVGA, InitCGA,
    TextMode, GraphMode, Plot, Width, Depth;

  PROCEDURE Fraktal(X, Y : REAL) : BOOLEAN;
    VAR C, D :  Complex;
        i    :  CARDINAL;
    BEGIN
      C.Re:=X; C.Im:=Y;
      D.Re:=0.0; D.Im:=0.0;
      i:=0;
      REPEAT
        CMUL(D,D,D);
        CSUB(D,C,D);
        IF CABS(D)>3.0 THEN RETURN FALSE END;
        INC(i);
      UNTIL i>20;
      RETURN TRUE;
    END Fraktal;

VAR X, Y : CARDINAL;
    XL, XH,
    YL, YH : REAL;
    c : CHAR;

BEGIN
  InitCGA;    (* Grafikkarte initialisieren *)
  XL:=-0.5; XH:=2.0;
  YL:=-1.0; YH:=2.0;
  LOOP
    ClrScr;
    FOR Y:=1 TO 24 DO
      FOR X:=1 TO 80 DO
        IF Fraktal(FLOAT(X-1)/79.0*XH+XL,FLOAT(24-Y)/23.0*YH+YL)
        THEN
          Write('X')
        ELSE
          Write(' ')
        END;
      END
    END;
    GotoXY(1,25);
    WriteString(' X = '); WriteReal(XL,6,4);
    WriteString(' ... '); WriteReal(XL+XH,6,4);
    WriteString(' Y = '); WriteReal(YL,6,4);
    WriteString(' ... '); WriteReal(YL+YH,6,4);
    c:=ReadKey();
    IF c=33C THEN (* Von hier an nur TopSpeed *)
      GraphMode;
      FOR X:=0 TO Width-1 DO
        FOR Y:=0 TO Depth-1 DO
          IF Fraktal(FLOAT(X)/FLOAT(Width-1)*XH+XL,
                     FLOAT(Depth-1-Y)/FLOAT(Depth-1)*YH+YL)
          THEN
            Plot(X,Y,1);
          END;
        END;
      END;
      c:=ReadKey();
      TextMode;
      WriteString(' X = '); WriteReal(XL,6,4);
      WriteString(' ... '); WriteReal(XL+XH,6,4);
      WriteString(' Y = '); WriteReal(YL,6,4);
      WriteString(' ... '); WriteReal(YL+YH,6,4);
      WriteLn;
    END; (* Bis hier *)
    WriteString(' NEU ? ');
    ReadReal(XL); IF NOT Done THEN EXIT END;
    ReadReal(XH); IF NOT Done THEN EXIT END;
    XH:=XH-XL;
    ReadReal(YL); IF NOT Done THEN EXIT END;
    ReadReal(YH); IF NOT Done THEN EXIT END;
    YH:=YH-YL;
    ReadLn;
  END;
END FRAKTALE.