IMPLEMENTATION MODULE INTEGRAL;

(* TYPE FUNC = PROCEDURE (LONGREAL) : LONGREAL; *)

PROCEDURE Integral(f : FUNC; a, b : LONGREAL; tol : REAL) : LONGREAL;
  CONST min = 8; (* es werden mind. 8 Intervalle berechnet *)
  VAR Result, h,
      x0, x1, xm,
      fa, fm, fb  : LONGREAL;
      j           : CARDINAL;

  PROCEDURE integriere(a, m, b, fa, fm, fb : LONGREAL);
    VAR I1, I2, h,
        m1, m2,
        fm1, fm2 : LONGREAL;

    BEGIN
      h:=b-a;
      m1:=(a+m)/2.0;
      fm1:=f(m1);
      m2:=(m+b)/2.0;
      fm2:=f(m2);
      I1:=(fa+4.0*fm+fb)*h/6.0;
      I2:=(7.0*(fa+fb)+32.0*(fm1+fm2)+12.0*fm)*h/90.0;
      IF VAL(REAL,ABS(I1-I2))>tol
      THEN
        integriere(a,m1,m,fa,fm1,fm);
        integriere(m,m2,b,fm,fm2,fb)
      ELSE
        Result:=Result+I2
      END
    END integriere;

  BEGIN
    Result:=0.0;
    h:=(b-a)/FLOAT(min);
    fb:=f(a); x1:=a;
    FOR j:=1 TO min DO
      x0:=x1;
      fa:=fb;
      x1:=x0+h;
      fb:=f(x1);
      xm:=(x0+x1)/2.0;
      fm:=f(xm);
      integriere(x0,xm,x1,fa,fm,fb)
    END;
    RETURN Result
  END Integral;

END INTEGRAL.