IMPLEMENTATION MODULE MENUE;

FROM SYSTEM IMPORT TSIZE;
FROM ChipIO IMPORT WriteString, Write, GotoXY, LowVideo, HighVideo,
                   ReadKey, TextColor, TextBackground;

PROCEDURE Auswahl(xPos, yPos, Breite, Spalten, Anzahl : CARDINAL;
                  Menue : ARRAY OF MenueString;
                  Buchstaben : ARRAY OF CHAR;
                  Abfrage, DarfESC : BOOLEAN;
                  VAR Wahl: CARDINAL; VAR Zeichen : CHAR);

  VAR Zeilen, i, j : CARDINAL;

  PROCEDURE Locate(Nr : CARDINAL);
    BEGIN
      GotoXY(xPos+((Nr-1) DIV Zeilen)*Breite,yPos+(Nr-1) MOD Zeilen)
    END Locate;

   PROCEDURE Blanks(n : CARDINAL; Invertiert : BOOLEAN);
     BEGIN
       IF Invertiert THEN InversAn END;
       WHILE n>0 DO Write(" "); DEC(n) END;
       IF Invertiert THEN InversAus END
     END Blanks;

   PROCEDURE WriteMenueString(S : ARRAY OF CHAR; Markiert : CHAR;
                              Invertiert : BOOLEAN);
     VAR First : BOOLEAN;
         i : CARDINAL;
     BEGIN
       IF Invertiert
       THEN InversAn; WriteString(S); InversAus;
       ELSE
         First:=TRUE; i:=0; MarkiertAus;
         WHILE (i<=HIGH(S)) AND (S[i]<>0C) DO
           IF First AND (S[i]=Markiert)
           THEN MarkiertAn; Write(S[i]); MarkiertAus
           ELSE Write(S[i])
           END;
           INC(i)
         END (* WHILE *)
       END (* IF *)
     END WriteMenueString;

   PROCEDURE Print(Nr : CARDINAL; Invertiert : BOOLEAN);
     VAR l,b : CARDINAL;
         Markiert : CHAR;
     BEGIN
       IF HIGH(Buchstaben)>=Nr-1
       THEN Markiert:=Buchstaben[Nr-1]
       ELSE Markiert:=0C
       END;
       Locate(Nr); l:=0;
       WHILE (l<TSIZE(MenueString)) AND (Menue[Nr-1][l]<>0C) DO INC(l) END;
       IF Breite>l THEN b:=(Breite-l) DIV 2 ELSE b:=0 END;
       IF Zeilen=1 THEN Blanks(b,Invertiert) END;
       WriteMenueString(Menue[Nr-1],Markiert,Invertiert);
       IF Zeilen=1 THEN Blanks(Breite-l-b,Invertiert) END;
     END Print;

   PROCEDURE ChangeHighLight(VAR alt, neu : CARDINAL);
     BEGIN
       Print(alt,FALSE);
       Print(neu,TRUE);
       alt:=neu;
     END ChangeHighLight;

   BEGIN
     (*Anzahl:=1+HIGH(Menue);*)
     Zeilen:=(Anzahl+Spalten-1) DIV Spalten;
     IF (Wahl>Anzahl) OR (Wahl<1) THEN Wahl:=1 END;
     FOR i:=1 TO Anzahl DO
       IF i=Wahl THEN Print(i,TRUE) ELSE Print(i,FALSE) END;
     END; (* FOR *)
     Locate(Wahl); i:=Wahl;
     IF Abfrage THEN
       REPEAT
         IF i<>Wahl THEN ChangeHighLight(i,Wahl); END;
         Locate(Wahl);
         Zeichen:=LiesZeichen();
         CASE Zeichen OF
           0C     :
         | SHoch  : Wahl:=1;
         | STief  : Wahl:=Anzahl;
         | Links  : IF Spalten=1 THEN RETURN END;
                    IF Wahl>Zeilen
                    THEN Wahl:=Wahl-Zeilen
                    ELSIF Wahl>1 THEN
                      Wahl:=Wahl+(Spalten-1)*Zeilen-1
                    END;
                    IF Wahl>Anzahl THEN Wahl:=Wahl-Zeilen END;
         | Rechts : IF Spalten=1 THEN RETURN END;
                    IF Wahl<=Anzahl-Zeilen
                    THEN Wahl:=Wahl+Zeilen
                    ELSIF (Wahl-1) MOD Zeilen<>(Zeilen-1)
                    THEN
                      IF Wahl<(Spalten-1)*Zeilen THEN Wahl:=Wahl+Zeilen END;
                      Wahl:=Wahl-(Spalten-1)*Zeilen+1;
                    END;
         | Hoch  : IF Spalten=Anzahl THEN RETURN END;
                   IF Wahl>1 THEN Wahl:=Wahl-1 END;
         | Tief  : IF Spalten=Anzahl THEN RETURN END;
                   IF Wahl<Anzahl THEN Wahl:=Wahl+1 END;
         | ESC   : IF (Zeilen>1) OR (Anzahl=1) OR DarfESC
                   THEN RETURN
                   END;
         | ' '   : IF Wahl<Anzahl THEN INC(Wahl) ELSE Wahl:=1 END
         ELSE (* CASE *)
           j:=0;
           WHILE (j<=HIGH(Buchstaben)) AND
                 (CAP(Buchstaben[j])<>CAP(Zeichen)) DO INC(j)
           END; (* WHILE *)
           IF (j<=HIGH(Buchstaben)) AND (j<Anzahl)
           THEN
             Wahl:=j+1;
             IF Wahl<>i THEN ChangeHighLight(i,Wahl) END;
             RETURN;
           END; (* IF *)
         END (* CASE *)
       UNTIL Zeichen=ENTER;
     END (* IF Abfrage *)
   END Auswahl;

PROCEDURE InvAn;
  BEGIN
    TextColor(0); TextBackground(7)
  END InvAn;

PROCEDURE InvAus;
  BEGIN
    TextColor(7); TextBackground(0)
  END InvAus;

BEGIN
  LiesZeichen:=ReadKey;
  MarkiertAn:=HighVideo;
  MarkiertAus:=LowVideo;
  InversAn:=InvAn;
  InversAus:=InvAus;
END MENUE.
